'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _seleniumWebdriver = require('selenium-webdriver');

var _lodash = require('lodash');

var _component = require('./component');

var _component2 = _interopRequireDefault(_component);

var _componentWidgetRecentPosts = require('./component-widget-recent-posts');

var _componentWidgetRecentPosts2 = _interopRequireDefault(_componentWidgetRecentPosts);

var _componentWidgetRecentComments = require('./component-widget-recent-comments');

var _componentWidgetRecentComments2 = _interopRequireDefault(_componentWidgetRecentComments);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * External dependencies
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


/**
 * Internal dependencies
 */


var SIDEBAR_SELECTOR = _seleniumWebdriver.By.css('.widget-area');

var SIDEBAR_WIDGETS = {
	recentPosts: _componentWidgetRecentPosts2.default,
	recentComments: _componentWidgetRecentComments2.default
};

var ComponentSidebar = function (_Component) {
	_inherits(ComponentSidebar, _Component);

	function ComponentSidebar(driver) {
		var selector = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : SIDEBAR_SELECTOR;
		var widgets = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : SIDEBAR_WIDGETS;

		_classCallCheck(this, ComponentSidebar);

		var _this = _possibleConstructorReturn(this, (ComponentSidebar.__proto__ || Object.getPrototypeOf(ComponentSidebar)).call(this, driver, selector));

		var sidebarWidgets = {};
		(0, _lodash.forEach)(widgets, function (ClassName, name) {
			sidebarWidgets[name] = new ClassName(driver);
		});

		_this.widgets = sidebarWidgets;
		return _this;
	}

	return ComponentSidebar;
}(_component2.default);

exports.default = ComponentSidebar;
module.exports = exports['default'];