'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _seleniumWebdriver = require('selenium-webdriver');

var _wpE2eWebdriver = require('wp-e2e-webdriver');

var _component = require('../component');

var _component2 = _interopRequireDefault(_component);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * External dependencies
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


/**
 * Internal dependencies
 */


var MY_ACCOUNT_SELECTOR = _seleniumWebdriver.By.css('#wp-admin-bar-my-account');

var ComponentAdminBarMyAccount = function (_Component) {
	_inherits(ComponentAdminBarMyAccount, _Component);

	function ComponentAdminBarMyAccount(driver) {
		var selector = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : MY_ACCOUNT_SELECTOR;

		_classCallCheck(this, ComponentAdminBarMyAccount);

		return _possibleConstructorReturn(this, (ComponentAdminBarMyAccount.__proto__ || Object.getPrototypeOf(ComponentAdminBarMyAccount)).call(this, driver, selector, { wait: false }));
	}

	_createClass(ComponentAdminBarMyAccount, [{
		key: 'hasSubmenu',
		value: function hasSubmenu(submenu) {
			this.hoverMyAccount();
			return _wpE2eWebdriver.WebDriverHelper.isEventuallyPresentAndDisplayed(this.driver, _seleniumWebdriver.By.xpath(this._getSubmenuXpathExpression(submenu)));
		}
	}, {
		key: 'click',
		value: function click() {
			return _wpE2eWebdriver.WebDriverHelper.clickWhenClickable(this.driver, MY_ACCOUNT_SELECTOR);
		}
	}, {
		key: 'hoverMyAccount',
		value: function hoverMyAccount() {
			var el = this.driver.findElement(MY_ACCOUNT_SELECTOR);
			this.driver.actions().mouseMove(el).perform();
		}
	}, {
		key: 'hoverMyAccountThenClickSubmenu',
		value: function hoverMyAccountThenClickSubmenu(submenu) {
			this.hoverMyAccount();
			return _wpE2eWebdriver.WebDriverHelper.clickWhenClickable(this.driver, _seleniumWebdriver.By.xpath(this._getSubmenuXpathExpression(submenu)));
		}
	}, {
		key: '_getSubmenuXpathExpression',
		value: function _getSubmenuXpathExpression(submenu) {
			return '//li[@id="wp-admin-bar-my-account"]' + ('//ul[contains(@class, "ab-submenu")]/li/a[contains(text(), "' + submenu + '")]');
		}
	}]);

	return ComponentAdminBarMyAccount;
}(_component2.default);

exports.default = ComponentAdminBarMyAccount;
module.exports = exports['default'];