'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _seleniumWebdriver = require('selenium-webdriver');

var _wpE2eWebdriver = require('wp-e2e-webdriver');

var _component = require('../component');

var _component2 = _interopRequireDefault(_component);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * External dependencies
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


/**
 * Internal dependencies
 */


var MENU_SELECTOR = _seleniumWebdriver.By.css('#adminmenu');

var ComponentAdminMenu = function (_Component) {
	_inherits(ComponentAdminMenu, _Component);

	function ComponentAdminMenu(driver) {
		var selector = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : MENU_SELECTOR;

		_classCallCheck(this, ComponentAdminMenu);

		return _possibleConstructorReturn(this, (ComponentAdminMenu.__proto__ || Object.getPrototypeOf(ComponentAdminMenu)).call(this, driver, selector, { wait: false }));
	}

	_createClass(ComponentAdminMenu, [{
		key: 'hasMenu',
		value: function hasMenu(menu) {
			return _wpE2eWebdriver.WebDriverHelper.isEventuallyPresentAndDisplayed(this.driver, _seleniumWebdriver.By.xpath(this._getMenuXpathExpression(menu)));
		}
	}, {
		key: 'hasMenuWithSubmenu',
		value: function hasMenuWithSubmenu(menu, submenu) {
			// Hover in menu.
			var el = this.driver.findElement(_seleniumWebdriver.By.xpath(this._getMenuXpathExpression(menu)));
			this.driver.actions().mouseMove(el).perform();

			return _wpE2eWebdriver.WebDriverHelper.isEventuallyPresentAndDisplayed(this.driver, _seleniumWebdriver.By.xpath(this._getSubmenuXpathExpression(menu, submenu)));
		}
	}, {
		key: 'click',
		value: function click(menu) {
			var selector = _seleniumWebdriver.By.xpath(this._getMenuXpathExpression(menu));

			return _wpE2eWebdriver.WebDriverHelper.clickWhenClickable(this.driver, selector);
		}
	}, {
		key: 'hoverMenuThenClickSubmenu',
		value: function hoverMenuThenClickSubmenu(menu, submenu) {
			// Hover in menu.
			var el = this.driver.findElement(_seleniumWebdriver.By.xpath(this._getMenuXpathExpression(menu)));
			this.driver.actions().mouseMove(el).perform();

			return _wpE2eWebdriver.WebDriverHelper.clickWhenClickable(this.driver, _seleniumWebdriver.By.xpath(this._getSubmenuXpathExpression(menu, submenu)));
		}
	}, {
		key: '_getMenuXpathExpression',
		value: function _getMenuXpathExpression(menu) {
			return '//ul[@id="adminmenu"]/li/a[.//div[contains(@class, "wp-menu-name") and contains(text(), "' + menu + '")]]';
		}
	}, {
		key: '_getSubmenuXpathExpression',
		value: function _getSubmenuXpathExpression(menu, submenu) {
			return '//ul[@id="adminmenu"]' + ('/li[./a//div[contains(@class, "wp-menu-name") and contains(text(), "' + menu + '")]]') + ('/ul[contains(@class, "wp-submenu")]/li/a[contains(text(), "' + submenu + '")]');
		}
	}]);

	return ComponentAdminMenu;
}(_component2.default);

exports.default = ComponentAdminMenu;
module.exports = exports['default'];