'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _seleniumWebdriver = require('selenium-webdriver');

var _wpE2eWebdriver = require('wp-e2e-webdriver');

var _componentMetaBox = require('./component-meta-box');

var _componentMetaBox2 = _interopRequireDefault(_componentMetaBox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * External dependencies
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


/**
 * Internal dependencies
 */


var CATEGORIES_PANEL = _seleniumWebdriver.By.xpath('//button[contains(text(), "Categories")]');
var METABOX_SELECTOR = _seleniumWebdriver.By.css('#categorydiv');
var ADD_NEW_SELECTOR = _seleniumWebdriver.By.css('.editor-post-taxonomies__hierarchical-terms-add');
var NEW_CATEGORY_FIELD_SELECTOR = _seleniumWebdriver.By.css('#editor-post-taxonomies__hierarchical-terms-input-0');
var NEW_CATEGORY_PARENT_SELECTOR = _seleniumWebdriver.By.css('#inspector-select-control-1');
var NEW_CATEGORY_SUBMIT_SELECTOR = _seleniumWebdriver.By.css('.editor-post-taxonomies__hierarchical-terms-submit');

var ComponentMetaBoxCategories = function (_ComponentMetaBox) {
	_inherits(ComponentMetaBoxCategories, _ComponentMetaBox);

	function ComponentMetaBoxCategories(driver) {
		_classCallCheck(this, ComponentMetaBoxCategories);

		return _possibleConstructorReturn(this, (ComponentMetaBoxCategories.__proto__ || Object.getPrototypeOf(ComponentMetaBoxCategories)).call(this, driver, METABOX_SELECTOR, { wait: false }));
	}

	_createClass(ComponentMetaBoxCategories, [{
		key: 'addCategory',
		value: function addCategory(category) {
			var parent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';


			// Open category panel
			_wpE2eWebdriver.WebDriverHelper.clickWhenClickable(this.driver, CATEGORIES_PANEL);

			// Open new category panel after it loads
			_wpE2eWebdriver.WebDriverHelper.waitTillPresentAndDisplayed(this.driver, ADD_NEW_SELECTOR);

			_wpE2eWebdriver.WebDriverHelper.clickWhenClickable(this.driver, ADD_NEW_SELECTOR);

			_wpE2eWebdriver.WebDriverHelper.setWhenSettable(this.driver, NEW_CATEGORY_FIELD_SELECTOR, category);

			if (parent) {
				var select = this.driver.findElement(NEW_CATEGORY_PARENT_SELECTOR);

				select.click();
				select.findElement(_seleniumWebdriver.By.xpath('./option[contains(text(),"' + parent + '")]')).click();
			}

			_wpE2eWebdriver.WebDriverHelper.clickWhenClickable(this.driver, NEW_CATEGORY_SUBMIT_SELECTOR);

			return _wpE2eWebdriver.WebDriverHelper.isEventuallyPresentAndDisplayed(this.driver, _seleniumWebdriver.By.xpath('label[@class="components-checkbox-control__label"] and contains(text(), "' + category + '")'));
		}
	}]);

	return ComponentMetaBoxCategories;
}(_componentMetaBox2.default);

exports.default = ComponentMetaBoxCategories;
module.exports = exports['default'];