'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _seleniumWebdriver = require('selenium-webdriver');

var _wpE2eWebdriver = require('wp-e2e-webdriver');

var _componentMetaBox = require('./component-meta-box');

var _componentMetaBox2 = _interopRequireDefault(_componentMetaBox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * External dependencies
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


/**
 * Internal dependencies
 */


var METABOX_SELECTOR = _seleniumWebdriver.By.css('#submitdiv');
var UPDATE_SELECTOR = _seleniumWebdriver.By.css('.editor-post-publish-button');
var PUBLISH_SELECTOR = _seleniumWebdriver.By.css('.editor-post-publish-panel__toggle');
var DRAFT_SELECTOR = _seleniumWebdriver.By.css('.editor-post-save-draft');

var PENDING_STATUS_SELECTOR = _seleniumWebdriver.By.css('#inspector-checkbox-control-1');
var MOVE_TO_TRASH_SELECTOR = _seleniumWebdriver.By.css('.editor-post-trash');

var STATUS_DRAFT_SELECTOR = _seleniumWebdriver.By.xpath('//span[contains(@class, "editor-post-saved-state") and contains(text(), "Saved")]');
var STATUS_UPDATED_SELECTOR = _seleniumWebdriver.By.xpath('//div[contains(@class, "editor-post-publish-panel__header-published") and contains(text(), "Published")]');
var STATUS_PUBLISHED_SELECTOR = _seleniumWebdriver.By.xpath('//button[contains(@class, "editor-post-publish-button") and contains(text(), "Update")]');
var STATUS_SCHEDULED_SELECTOR = _seleniumWebdriver.By.xpath('//button[contains(@class, "editor-post-publish-button") and contains(text(), "Schedule")]');
var STATUS_PENDING_SELECTOR = _seleniumWebdriver.By.css('#inspector-checkbox-control-1[checked]');

var ComponentMetaBoxPublish = function (_ComponentMetaBox) {
	_inherits(ComponentMetaBoxPublish, _ComponentMetaBox);

	function ComponentMetaBoxPublish(driver) {
		_classCallCheck(this, ComponentMetaBoxPublish);

		return _possibleConstructorReturn(this, (ComponentMetaBoxPublish.__proto__ || Object.getPrototypeOf(ComponentMetaBoxPublish)).call(this, driver, METABOX_SELECTOR, { wait: false }));
	}

	_createClass(ComponentMetaBoxPublish, [{
		key: 'publish',
		value: function publish() {
			_wpE2eWebdriver.WebDriverHelper.mouseMoveTo(this.driver, PUBLISH_SELECTOR);
			_wpE2eWebdriver.WebDriverHelper.clickWhenClickable(this.driver, PUBLISH_SELECTOR);

			_wpE2eWebdriver.WebDriverHelper.isEventuallyPresentAndDisplayed(this.driver, UPDATE_SELECTOR);

			return this.save();
		}
	}, {
		key: 'save',
		value: function save() {
			_wpE2eWebdriver.WebDriverHelper.mouseMoveTo(this.driver, UPDATE_SELECTOR);
			_wpE2eWebdriver.WebDriverHelper.clickWhenClickable(this.driver, UPDATE_SELECTOR);

			return _wpE2eWebdriver.WebDriverHelper.isEventuallyPresentAndDisplayed(this.driver, STATUS_UPDATED_SELECTOR);
		}
	}, {
		key: 'saveDraft',
		value: function saveDraft() {
			_wpE2eWebdriver.WebDriverHelper.mouseMoveTo(this.driver, DRAFT_SELECTOR);
			_wpE2eWebdriver.WebDriverHelper.clickWhenClickable(this.driver, DRAFT_SELECTOR);

			return _wpE2eWebdriver.WebDriverHelper.isEventuallyPresentAndDisplayed(this.driver, STATUS_DRAFT_SELECTOR);
		}
	}, {
		key: 'setPendingReview',
		value: function setPendingReview() {
			_wpE2eWebdriver.WebDriverHelper.mouseMoveTo(this.driver, PENDING_STATUS_SELECTOR);
			_wpE2eWebdriver.WebDriverHelper.clickWhenClickable(this.driver, PENDING_STATUS_SELECTOR);

			return _wpE2eWebdriver.WebDriverHelper.isEventuallyPresentAndDisplayed(this.driver, STATUS_PENDING_SELECTOR);
		}
	}, {
		key: '_getStatusSelector',
		value: function _getStatusSelector(status) {
			switch (status) {
				case 'Published':
					return STATUS_PUBLISHED_SELECTOR;
				case 'Draft':
					return STATUS_DRAFT_SELECTOR;
				case 'Pending Review':
					return STATUS_PENDING_SELECTOR;
				case 'Scheduled':
					return STATUS_SCHEDULED_SELECTOR;
			}
		}
	}, {
		key: 'hasStatus',
		value: function hasStatus(status) {
			return _wpE2eWebdriver.WebDriverHelper.isEventuallyPresentAndDisplayed(this.driver, this._getStatusSelector(status));
		}
	}, {
		key: 'moveToTrash',
		value: function moveToTrash() {
			_wpE2eWebdriver.WebDriverHelper.mouseMoveTo(this.driver, MOVE_TO_TRASH_SELECTOR);
			return _wpE2eWebdriver.WebDriverHelper.clickWhenClickable(this.driver, MOVE_TO_TRASH_SELECTOR);
		}
	}]);

	return ComponentMetaBoxPublish;
}(_componentMetaBox2.default);

exports.default = ComponentMetaBoxPublish;
module.exports = exports['default'];