'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _seleniumWebdriver = require('selenium-webdriver');

var _wpE2eWebdriver = require('wp-e2e-webdriver');

var _component = require('../component');

var _component2 = _interopRequireDefault(_component);

var _componentPluginCard = require('./component-plugin-card');

var _componentPluginCard2 = _interopRequireDefault(_componentPluginCard);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * External dependencies
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


/**
 * External dependencies
 */


var FILTER_SELECTOR = _seleniumWebdriver.By.css('.wp-filter');
var TAB_FEATURED_SELECTOR = _seleniumWebdriver.By.css('.plugin-install-featured');
var TAB_POPULAR_SELECTOR = _seleniumWebdriver.By.css('.plugin-install-popular');
var TAB_RECOMMENDED_SELECTOR = _seleniumWebdriver.By.css('.plugin-install-recommended');
var TAB_FAVORITES_SELECTOR = _seleniumWebdriver.By.css('.plugin-install-favorites');
var SEARCH_PLUGINS_SELECTOR = _seleniumWebdriver.By.css('.wp-filter-search');

var ComponentPluginInstallFilter = function (_Component) {
	_inherits(ComponentPluginInstallFilter, _Component);

	function ComponentPluginInstallFilter(driver) {
		var selector = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : FILTER_SELECTOR;

		_classCallCheck(this, ComponentPluginInstallFilter);

		var _this = _possibleConstructorReturn(this, (ComponentPluginInstallFilter.__proto__ || Object.getPrototypeOf(ComponentPluginInstallFilter)).call(this, driver, selector));

		_this.tabs = {};
		_this.tabs.featured = driver.findElement(TAB_FEATURED_SELECTOR);
		_this.tabs.popular = driver.findElement(TAB_POPULAR_SELECTOR);
		_this.tabs.recommended = driver.findElement(TAB_RECOMMENDED_SELECTOR);
		_this.tabs.favorites = driver.findElement(TAB_FAVORITES_SELECTOR);
		return _this;
	}

	_createClass(ComponentPluginInstallFilter, [{
		key: 'search',
		value: function search(pluginSlug) {
			_wpE2eWebdriver.WebDriverHelper.setWhenSettable(this.driver, SEARCH_PLUGINS_SELECTOR, pluginSlug);
			return new _componentPluginCard2.default(this.driver, pluginSlug);
		}
	}]);

	return ComponentPluginInstallFilter;
}(_component2.default);

exports.default = ComponentPluginInstallFilter;
module.exports = exports['default'];