'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _seleniumWebdriver = require('selenium-webdriver');

var _wpE2eWebdriver = require('wp-e2e-webdriver');

var _component = require('../component');

var _component2 = _interopRequireDefault(_component);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * External dependencies
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


/**
 * External dependencies
 */


var PLUGINS_LIST_SELECTOR = _seleniumWebdriver.By.css('#the-list');
var MESSAGE_DISMISS_SELECTOR = _seleniumWebdriver.By.css('#message button');
var PLUGIN_DELETED_SELECTOR = _seleniumWebdriver.By.css('.plugin-deleted-tr');

var ComponentPluginsList = function (_Component) {
	_inherits(ComponentPluginsList, _Component);

	function ComponentPluginsList(driver) {
		var selector = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : PLUGINS_LIST_SELECTOR;

		_classCallCheck(this, ComponentPluginsList);

		return _possibleConstructorReturn(this, (ComponentPluginsList.__proto__ || Object.getPrototypeOf(ComponentPluginsList)).call(this, driver, selector));
	}

	_createClass(ComponentPluginsList, [{
		key: 'activate',
		value: function activate(pluginSlug) {
			return this.perform(pluginSlug, 'activate');
		}
	}, {
		key: 'deactivate',
		value: function deactivate(pluginSlug) {
			return this.perform(pluginSlug, 'deactivate');
		}
	}, {
		key: 'delete',
		value: function _delete(pluginSlug) {
			return this.perform(pluginSlug, 'delete');
		}
	}, {
		key: 'perform',
		value: function perform(pluginSlug) {
			var action = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'activate';

			var cssSelector = this.getPluginActionCssSelector(pluginSlug, action);
			var actionSelector = _seleniumWebdriver.By.css(cssSelector);
			var self = this;

			return this.driver.findElement(actionSelector).then(function () {
				switch (action) {
					case 'activate':
					case 'deactivate':
						_wpE2eWebdriver.WebDriverHelper.clickWhenClickable(self.driver, actionSelector);
						return _wpE2eWebdriver.WebDriverHelper.clickWhenClickable(self.driver, MESSAGE_DISMISS_SELECTOR);
					case 'delete':
						_wpE2eWebdriver.WebDriverHelper.clickWhenClickable(self.driver, actionSelector);

						// Delete plugin triggers popup.
						self.driver.switchTo().alert().accept();

						return _wpE2eWebdriver.WebDriverHelper.isEventuallyPresentAndDisplayed(self.driver, PLUGIN_DELETED_SELECTOR);
				}
			}, function () {
				return false;
			});
		}
	}, {
		key: 'getPluginActionCssSelector',
		value: function getPluginActionCssSelector(pluginSlug) {
			var action = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'activate';

			var state = action === 'deactivate' ? 'active' : 'inactive';
			return 'tr.' + state + '[data-slug="' + pluginSlug + '"] .' + action;
		}
	}]);

	return ComponentPluginsList;
}(_component2.default);

exports.default = ComponentPluginsList;
module.exports = exports['default'];