'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _seleniumWebdriver = require('selenium-webdriver');

var _wpE2eWebdriver = require('wp-e2e-webdriver');

var _component = require('../component');

var _component2 = _interopRequireDefault(_component);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * External dependencies
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


/**
 * Internal dependencies
 */


var POSTS_LIST_SELECTOR = _seleniumWebdriver.By.css('#posts-filter');
var SEARCH_INPUT_SELECTOR = _seleniumWebdriver.By.css('#post-search-input');
var SEARCH_SUBMIT_SELECTOR = _seleniumWebdriver.By.css('#search-submit');

var ComponentPostsList = function (_Component) {
	_inherits(ComponentPostsList, _Component);

	function ComponentPostsList(driver) {
		var selector = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : POSTS_LIST_SELECTOR;

		_classCallCheck(this, ComponentPostsList);

		return _possibleConstructorReturn(this, (ComponentPostsList.__proto__ || Object.getPrototypeOf(ComponentPostsList)).call(this, driver, _seleniumWebdriver.By.css(selector)));
	}

	_createClass(ComponentPostsList, [{
		key: 'search',
		value: function search(keyword) {
			_wpE2eWebdriver.WebDriverHelper.mouseMoveTo(this.driver, SEARCH_INPUT_SELECTOR);
			_wpE2eWebdriver.WebDriverHelper.setWhenSettable(this.driver, SEARCH_INPUT_SELECTOR, keyword);
			return _wpE2eWebdriver.WebDriverHelper.clickWhenClickable(this.driver, SEARCH_SUBMIT_SELECTOR);
		}
	}, {
		key: 'editPostWithTitle',
		value: function editPostWithTitle(title) {
			this._mouseOverPostTitle(title);
			return _wpE2eWebdriver.WebDriverHelper.clickWhenClickable(this.driver, this._getPostTitleSelector(title));
		}
	}, {
		key: 'viewPostWithTitle',
		value: function viewPostWithTitle(title) {
			this._mouseOverPostTitle(title);
			return _wpE2eWebdriver.WebDriverHelper.clickWhenClickable(this.driver, this._getRowActionSelector(title, 'view'));
		}
	}, {
		key: 'trashPostWithTitle',
		value: function trashPostWithTitle(title) {
			this._mouseOverPostTitle(title);
			return _wpE2eWebdriver.WebDriverHelper.clickWhenClickable(this.driver, this._getRowActionSelector(title, 'trash'));
		}
	}, {
		key: '_getPostTitleSelector',
		value: function _getPostTitleSelector(title) {
			return _seleniumWebdriver.By.xpath(this._getPostTitleXpathExpression(title));
		}
	}, {
		key: '_getRowActionSelector',
		value: function _getRowActionSelector(title, action) {
			return _seleniumWebdriver.By.xpath(this._getRowActionXpathExpression(title, action));
		}
	}, {
		key: '_getPostTitleXpathExpression',
		value: function _getPostTitleXpathExpression(title) {
			return '//a[@class=\'row-title\' and text()=\'' + title + '\']';
		}
	}, {
		key: '_getRowActionXpathExpression',
		value: function _getRowActionXpathExpression(title, action) {
			return '//td[(contains(@class, "column-title")) and .' + this._getPostTitleXpathExpression(title) + ']' + ('//*[contains(@class, "' + action + '")]/a');
		}
	}, {
		key: '_mouseOverPostTitle',
		value: function _mouseOverPostTitle(title) {
			return _wpE2eWebdriver.WebDriverHelper.mouseMoveTo(this.driver, this._getPostTitleSelector(title));
		}
	}]);

	return ComponentPostsList;
}(_component2.default);

exports.default = ComponentPostsList;
module.exports = exports['default'];